Package: DeepTarget
Type: Package
Title: Deep characterization of cancer drugs
Version: 1.4.0
Authors@R: c(
    person("Sanju", "Sinha", email = "sanju@terpmail.umd.edu", role ="aut"),
    person("Trinh", "Nguyen", email = "tinh.nguyen@nih.gov", role = c("aut","cre"),comment=c(ORCID="0000-0002-6606-6948")),
    person("Ying", "Hu", email = "yhu@mail.nih.gov", role ="aut"))
Description: This package predicts a drug’s primary target(s) or secondary target(s) by integrating large-scale genetic and drug screens from the Cancer Dependency Map project run by the Broad Institute. It further investigates whether the drug specifically targets the wild-type or mutated target forms. To show how to use this package in practice, we provided sample data along with step-by-step example.
License: GPL-2
Encoding: UTF-8
biocViews: GeneTarget, GenePrediction,Pathways, GeneExpression, RNASeq,
        ImmunoOncology,DifferentialExpression, GeneSetEnrichment,
        ReportWriting,CRISPR
RoxygenNote: 7.2.3
VignetteBuilder: knitr
Suggests: BiocStyle, knitr, rmarkdown
Imports: fgsea, ggplot2, stringr, ggpubr, BiocParallel, pROC, stats,
        grDevices, graphics, depmap, readr, dplyr
Depends: R (>= 4.2.0)
git_url: https://git.bioconductor.org/packages/DeepTarget
git_branch: RELEASE_3_22
git_last_commit: 5b8241e
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:31:21 UTC; biocbuild
Author: Sanju Sinha [aut],
  Trinh Nguyen [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-6606-6948>),
  Ying Hu [aut]
Maintainer: Trinh Nguyen <tinh.nguyen@nih.gov>

# DeepTarget
`DeepTarget` performs deep characterization of cancer drugs mechanism of action by integrating large-scale genetic and drug screens from the Cancer Dependency Map project run by the Broad Institute (depmap.org)  and aims to find drug's primary target(s), predict whether the drug specifically targets the wild-type or mutated target forms, and predict the secondary target(s) that mediate its response when the primary target is not expressed.
# Depmap license
The user of this package is required to agree to the terms and conditions of DepMap portal (https://depmap.org/portal/). 
Some of these terms and conditions are problematic for U.S. Federal Government employees, and they should consult their technology transfer office/legal office before agreeing to such terms and conditions.
## Installation
### GitHub installation
You can install the development version of DeepTarget from [GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("CBIIT-CGBB/DeepTarget")
```

### Bioconductor installation
In order to install the package from Bioconductor, make sure
`BiocManager` is installed and then install the package
`DeepTarget`:
``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("DeepTarget")
```
## Example

Please refer to the file named DeepTarget_Vignette.Rmd in the directory vignettes for a demonstration of how the package can be used.

## Data
For the purpose of demonstration, we include an OntargetM object that contains a subset of data from the Cancer Dependency Map (depmap.org). The full data set it too large for package memory constraints. For details and links to download the full data set, please use the  `??OntargetM` command.

## Citation
If you use `DeepTarget`, please consider adding the following
citation from bioRxiv preprint: (https://www.biorxiv.org/content/10.1101/2022.10.17.512424v1)
@article {Sinha2022.10.17.512424,
	author = {Sanju Sinha and Neelam Sinha and Eytan Ruppin},
	title = {Deep characterization of cancer drugs mechanism of action by integrating large-scale genetic and drug screens},
	elocation-id = {2022.10.17.512424},
	year = {2022},
	doi = {10.1101/2022.10.17.512424},
	publisher = {Cold Spring Harbor Laboratory},
	URL = {https://www.biorxiv.org/content/early/2022/10/19/2022.10.17.512424},
	eprint = {https://www.biorxiv.org/content/early/2022/10/19/2022.10.17.512424.full.pdf},
	journal = {bioRxiv}
}

## Function to pull out the gene target of a drug that has the max correlation.
PredTarget <- function(Sim.GES.DRS,D.M){
    ## Make sure the user use the same meta data for the list of Sim.GES.DRS
    Drug.Id.i <- match(names(Sim.GES.DRS), D.M[,1])
    D.M.f <- D.M[Drug.Id.i,]
    ## based on the name of the drug.
    Splt.targets <- str_split(as.character(D.M.f[,3]), ", ")
    F.V <- nrow(Sim.GES.DRS[[1]])
    corrMatPval <- vapply(Sim.GES.DRS, function(x) x[,1],numeric(F.V))
    corrMat <- vapply(Sim.GES.DRS, function(x) x[,2],numeric(F.V))
    corrMatFDR <- vapply(Sim.GES.DRS, function(x) x[,3],numeric(F.V))
    Stat.Drug <- bplapply(seq_len(length(Splt.targets)),function(x){
        ret_cor <- corrMat[
        match(Splt.targets[[x]],
        rownames(corrMat)), x]
        names(ret_cor) <- tryCatch(Splt.targets[[x]],error=function(e){NA})
        ret_cor
        })
    ## if there is one drug.
    if ( nrow(D.M.f)==1){
        ## Catch potential error of returning -Inf
        Target.Max.cor <- tryCatch(max(Stat.Drug,na.rm=TRUE ),
            error=function(e){NA})
        Target.Max.Name <- names(Stat.Drug)[which.max(Stat.Drug)]
        ## drug Id will be the same as the metadata.
        Drug.id <- names(Sim.GES.DRS)
        names(Target.Max.cor) <- as.character(D.M.f[,2])
    }else{
        names(Stat.Drug) <- as.character(D.M.f[,2])
        Target.Max.cor <- vapply(Stat.Drug,
            function(x) max(x, na.rm=TRUE),numeric(1))
        Target.Max.Name <- vapply(Stat.Drug,
            function(x) names(which.max(x)),character(1))
        Drug.id <- D.M.f[match(names(Target.Max.cor), D.M.f$name),1]
    }
    Target.Max.Name[vapply(Target.Max.Name, length,FUN.VALUE =numeric(1))==0] <- NA
    ## Obtain drug ID and make sure that we map the correct one
    Target.Pred <- data.frame(
        DrugID = Drug.id,
        drugName=names(Target.Max.cor),
        MaxTargetName=unlist(Target.Max.Name),
        Maxcorr=Target.Max.cor)
    ## Pull out p val and FDR.
    Target.Pred$KnownTargetCorrP <- vapply(seq_len(nrow(Target.Pred)), function(x)
        tryCatch(corrMatPval[Target.Pred[x,3], Target.Pred[x,1]],
        error=function(e){NA}),FUN.VALUE = numeric(1))
    # Known Target Significance - FDR corrected
    Target.Pred$KnownTargetCorrFDR <- vapply(seq_len(nrow(Target.Pred)), function(x)
        tryCatch(corrMatFDR[Target.Pred[x,3], Target.Pred[x,1]],
        error=function(e){NA}),FUN.VALUE = numeric(1))
    Target.Pred
}

## This version is pull the data from publicly available files that were shared by the depmap consortium on figshare. 
Depmap2DeepTarget <- function(FileN,version){
    out <- depmap::dmsets() |> dplyr::filter(grepl(version, title))
    if (nrow(out)==0){stop("please check FileName and its version")}
    for ( i in seq_len(nrow(out))){
        d.id <- out$dataset_id[i]
        Found.i <-  depmap::dmfiles() |>filter(dataset_id == d.id) |> filter(name == FileN)
        if (nrow(Found.i)>0){break}
    }
    if (nrow(Found.i)==0){
        stop("This file is not available for this version")
    }else{
        ## download and read the file.
        out.f <- depmap::dmfiles() |>filter(dataset_id == d.id) |> filter(name == FileN) |>
            dmget() |>
            read_csv()
        if (FileN=="CCLE_expression.csv" || FileN=="CRISPRGeneEffect.csv"){
            out.t <- t(out.f)
            colnames(out.t) <-  out.t[1,]
            out.t <- out.t[-1,]
            out.d <- as.data.frame(out.t)
            out.d$Gene <- row.names(out.d)
            # pre-processed
            Gene_name <- vapply(strsplit(out.d$Gene, '[ ()]'), "[", 1,FUN.VALUE = as.character(length(out.d$Gene)) )
            out.m <- cbind (Gene_name,out.d)
        }
        if (FileN=="OmicsSomaticMutations.csv"){
            mu_frame <- data.frame(ColumnName=out.f$DepMap_ID,
            RowName=out.f$HugoSymbol)
            ## remove silent one.
            filter_var_class <- "SILENT"
            f.i <- which(out.f$VariantInfo %in% filter_var_class)
            mu_frame <- mu_frame[-f.i,]
            # Unique column and row names
            unique_cols <- unique(mu_frame$ColumnName)
            unique_rows <- unique(mu_frame$RowName)
            # Create an empty matrix
            out.m <- matrix(0, nrow = length(unique_rows), ncol = length(unique_cols),
                dimnames = list(unique_rows, unique_cols))
            # Fill the matrix
            for(j in seq_len(nrow(out.m))){
                out.m[mu_frame$RowName[j], mu_frame$ColumnName[j]] <- 1
            }
            out.m <- as.data.frame(out.m)}
        if (FileN=="secondary-screen-dose-response-curve-parameters.csv"){
            # Area under the curve(AUC) is used; also, retrieve meta data for later use.
            out.f$Broad_id_trimmed <- vapply(strsplit(out.f$broad_id, "[-]"), "[", 2, FUN.VALUE = as.character(length(out.f$broad_id)))
            out.d.Auc <- data.frame(ColumnName=out.f$depmap_id,RowName=out.f$Broad_id_trimmed,Value=out.f$auc)
            out.d.Auc.m <- xtabs(Value ~ RowName + ColumnName, data = out.d.Auc)
            attr(out.d.Auc.m, "class") <- NULL
            attr(out.d.Auc.m, "call") <- NULL
            # annotation
            out.f.anno <- out.f[,c("broad_id","Broad_id_trimmed","name","target", "moa","smiles")]
            out.d.anno <- as.data.frame(out.f.anno)
            out.d.anno <- out.d.anno[!duplicated(out.d.anno$Broad_id_trimmed),]
            row.names(out.d.anno) <- out.d.anno$Broad_id_trimmed
            out.d.anno <- out.d.anno[row.names(out.d.Auc.m),]
            out.m <- cbind ( out.d.anno,out.d.Auc.m)}
            # return the dataframe if found
        return(out.m)
    }
}

## Function to execute the pathway analysis for a set of targets.
DoPWY <- function(Sim.GES.DRS,D.M){
    PwyTargeted <- split(D.M[,3], D.M[,5])
    PwyTargeted.unl <- lapply(PwyTargeted, unlist)
    PwyTargeted.c <- lapply(PwyTargeted.unl, function(y){
        unique(unlist(lapply(as.character(y), function(x)
            unlist(strsplit(x, ', ')))))
    })
    PwyTargeted.c <- bplapply( PwyTargeted.c, na.omit)
    F.V <- nrow(Sim.GES.DRS[[1]])
    corrMat <- vapply(Sim.GES.DRS, function(x) x[,2],numeric(F.V))
    DoPWYEnr <- bplapply(seq_len(ncol(corrMat)), function(x) {
        corrMat.ul <- unlist(corrMat[,x])
        names(corrMat.ul) <- row.names(corrMat)
        corrMat.ul.s <- sort(corrMat.ul, decreasing = TRUE)
	    corrMat.ul.s <- as.matrix(corrMat.ul.s)
	    corrMat.ul.s.u <- corrMat.ul.s[!duplicated(row.names(corrMat.ul.s)),]
        gseaEnr <- fgsea(
            pathways = PwyTargeted.c,stats = corrMat.ul.s.u,minSize=1,maxSize=100)
        gseaEnr})
    names(DoPWYEnr) <- colnames(corrMat)
    DoPWYEnr
}

## Function to calculate Drug Mutant Binding (DMB)
DMB <- function(DrugName,GOI,Pred,Mutant,DRS,GES,plot=TRUE){
    if (nrow (Pred)==0) {stop("Pred should contain drug of interest")}
    L.c <- list(
        KO= colnames(GES),Drug_Prism= colnames(DRS),Mutation= colnames(Mutant))
    CL.M <- Reduce(intersect,L.c)
    if ( DrugName %in% Pred[,2]){
        if (plot) {
            mutant  <- factor(Mutant[GOI,CL.M]);
            colcode <- mutant
            ## zero WT, 1 mutant.
            levels(colcode ) <- c('WT', 'Mutant')
            GES.c <- GES[GOI,CL.M]
            DRS.c <- DRS[Pred[DrugName,1],CL.M]
            Mutant.c <- colcode
            dat.c <- data.frame(GES.c,DRS.c,Mutant.c)
            ggplot(dat.c,
                aes(x = GES.c, y = DRS.c, color = factor(dat.c$Mutant.c)))+
                stat_smooth(method = 'lm')+
                theme_bw(base_size = 15)+
                labs(
                    x = 'Viability after CRISPR-KO', 
                    y = paste0('Response to ',Pred[DrugName,2]),
                    color =  paste0( GOI,'\nMutation\nstatus'))+
                stat_cor(label.y = c(1.3,1.4))
            }
    }else{
        stop("The drug of interest is not existed. Please double check.")}
}

# a helper function to plot a color bar.
colorBar<- function(xl, yb, xr, yt, v.min, v.max, col.l, alpha=1, color.spec="hsv",title=""){
    nticks <- 11; 
    ticks  <- seq(v.min, v.max, len=nticks);
    tmp.v  <- seq(v.min, v.max, length.out=100)
    lut    <- col.l;
    #lut   <- colorRampPalette(c("white", "red"))(100);
    xs    <- (xr-xl)/(length(lut)-1);
    xl.old <- xl;
    # change from 1:(length(lut)-1) to seq_len(length(lut)-1))
    for (i in seq_len(length(lut)-1)) {
        rect(xl.old, yb, xl.old+xs, yt, col=lut[i], border=NA)
        xl.old <- xl.old + xs;
    }
    v.med <- (v.max+v.min)/2;
    xm  <- (xl+xr)/2;
    v.max <- round(v.max,2);
    v.min <- round(v.min,2);
    v.med <- round(v.med,2);
    x.d   <- xr-xl;
    y.d   <- yt-yb;
    text(xl, yt+x.d, title, cex=1);
    text(xr, yb-y.d, v.max, cex=0.6);
    text(xl, yb-y.d, v.min, cex=0.6);
    text(xm, yb-y.d, v.med, cex=0.6);
    segments(xl, yb-y.d/5, xr,  yb-y.d/5, col="black", lwd=0.8);
    segments(xl, yb-y.d/5, xl,  yb-y.d/2, col="black", lwd=0.8);
    segments(xm, yb-y.d/5, xm,  yb-y.d/2, col="black", lwd=0.8);
    segments(xr, yb-y.d/5, xr,  yb-y.d/2, col="black", lwd=0.8);
}

# Function to compute the correlation for a drug.
computeCor <- function(DrugName,DRS,GES){
    common.c <- intersect(colnames(DRS),colnames(GES))
    DRS.c<- DRS[DrugName,common.c ]
    GES.c<- GES[,common.c]
    out.Sim.GES.DRS <- vapply(
        seq_len(nrow(GES.c)),
        function(x) unlist(cor.test(DRS.c, GES.c[x,])),FUN.VALUE=character(10))
    p.value <- t(out.Sim.GES.DRS["p.value",])
    estimate.cor <- t(out.Sim.GES.DRS["estimate.cor",])
    FDR <- p.adjust(p.value,method = 'fdr')
    out.Sim.GES.DRS.c <- cbind(as.numeric(p.value),as.numeric(estimate.cor),as.numeric(FDR))
    row.names(out.Sim.GES.DRS.c) <- row.names(GES.c)
    colnames(out.Sim.GES.DRS.c) <- c("p.value","estimate.cor","FDR")
    out.Sim.GES.DRS.c
}

## Function to predict the maximum similarity for gene targets.
PredMaxSim <- function(Sim.GES.DRS,D.M){
    Drug.Id.i <- match(names(Sim.GES.DRS), D.M[,1])
    D.M.f <- D.M[Drug.Id.i,]
    ## based on the name of the drug.
    Splt.targets <- str_split(as.character(D.M.f[,3]), ", ")
    F.V <- nrow(Sim.GES.DRS[[1]])
    corrMatPval <- vapply(Sim.GES.DRS, function(x) x[,1],numeric(F.V))
    corrMat <- vapply(Sim.GES.DRS, function(x) x[,2],numeric(F.V))
    corrMatFDR <- vapply(Sim.GES.DRS, function(x) x[,3],numeric(F.V))
    ## if there is one drug.
    if ( nrow(D.M.f)==1){
        BestTargetGene <- rownames(corrMat)[which.max(corrMat[,1])]
        BestTargetCorr <-  max(corrMat[,1],na.rm = TRUE)
        Drug.id <- names(Sim.GES.DRS)
    }else{
        ## 2 is the column.
        BestTargetGene <- apply(
            corrMat,2, function(x) rownames(corrMat)[which.max(x)] )
        BestTargetCorr <- apply(
            corrMat,2, function(x) max(x, na.rm = TRUE) )
        Drug.id <- names(BestTargetGene)
    }
    Pred.sim <- data.frame(
        DrugID = Drug.id, BestTargetGene=unlist(BestTargetGene),
        BestTargetCorr=BestTargetCorr)
    ## map to get the P val from best target gene
    Pred.sim$BestTargetCorrP <- vapply(seq_len(nrow(Pred.sim)), function(x)
    tryCatch(corrMatPval[Pred.sim[x,'BestTargetGene'], Pred.sim[x,1]], 
        error=function(e){NA}),numeric(1))
    ## Best Hit Significance - FDR corrected
    Pred.sim$BestTargetCorrFDR <- vapply(seq_len(nrow(Pred.sim)),function(x) 
        tryCatch(corrMatFDR[Pred.sim[x,'BestTargetGene'], Pred.sim[x,1]],
            error=function(e){NA}), numeric(1))
    Pred.sim
}

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE,
    cache = TRUE
)

## ----Data Loading and Preparation---------------------------------------------

library(DeepTarget)
data("OntargetM")
## "Below is the OnTargetM object containing a subset of public data downloading from depmap.org"
vapply(OntargetM,dim,FUN.VALUE = numeric(2))
## drug of interest.
drug.name <- c('atiprimod','AMG-232','pitavastatin','Ro-4987655','alexidine','RGFP966','dabrafenib','olaparib','CGM097','ibrutinib','palbociclib')
## data preparation for these drugs
## the secondary prism contain the response scores, where columns are cell lines and row names for Broad IDs of the drug.
## First, Obtain the broad ID for these interesting drug.
Broad.IDs <- OntargetM$DrugMetadata$broad_id_trimmed[which(OntargetM$DrugMetadata$name %in% drug.name)]
## the drug response has duplicated assays so we have 16 rows returned for 11 drugs.
sec.prism.f <- OntargetM$secondary_prism[which ( row.names(OntargetM$secondary_prism) %in% Broad.IDs), ]
KO.GES <- OntargetM$avana_CRISPR


## ----Computing a correlation between the every gene crispr KO vs each drug response for all interesting drugs----
List.sim <- NULL;
for (i in 1:nrow(sec.prism.f)){
    DRS <- as.data.frame(sec.prism.f[i,])
    DRS <- t(DRS)
    row.names(DRS) <- row.names(sec.prism.f)[i]
    out <- computeCor(row.names(sec.prism.f)[i],DRS,KO.GES)
    List.sim [[length(List.sim) + 1]] <- out
}
names(List.sim) <- row.names(sec.prism.f)


## ----section.cap="Predicting Similarity Across Known Targeted Genes and All Genes"----
metadata <- OntargetM$DrugMetadata
DrugTarcomputeCor <- PredTarget(List.sim,metadata)
DrugGeneMaxSim <- PredMaxSim(List.sim,metadata)


## ----section.cap="Computing the Interaction"----------------------------------
d.mt <- OntargetM$mutations_mat
d.expr <- OntargetM$expression_20Q4
out.MutantTarget <- NULL;
out.LowexpTarget <- NULL;
for (i in 1:nrow(sec.prism.f)){
    DRS=as.data.frame(sec.prism.f[i,])
    DRS <- t(DRS)
    row.names(DRS) <- row.names(sec.prism.f)[i]
    ## for mutant
    Out.M <- DoInteractMutant(DrugTarcomputeCor[i,],d.mt,DRS,KO.GES)
    TargetMutSpecificity <- data.frame(MaxTgt_Inter_Mut_strength=vapply(Out.M, function(x)  x[1],numeric(1)), MaxTgt_Inter_Mut_Pval=vapply(Out.M, function(x) x[2],numeric(1)))
    out.MutantTarget <- rbind(out.MutantTarget,TargetMutSpecificity)
    ## for expression.
    Out.Expr <- DoInteractExp(DrugTarcomputeCor[i,],d.expr,DRS,KO.GES,CutOff= 2)
    TargetExpSpecificity <- data.frame(
    MaxTgt_Inter_Exp_strength <- vapply(Out.Expr, function(x) x[1],numeric(1)),
    MaxTgt_Inter_Exp_Pval <- vapply(Out.Expr, function(x) x[2],numeric(1)))
    out.LowexpTarget <- rbind (out.LowexpTarget,TargetExpSpecificity)
}


## ----Interaction Assessment---------------------------------------------------
Whether_interaction_Ex_based= ifelse( out.LowexpTarget$MaxTgt_Inter_Exp_strength <0
& out.LowexpTarget$MaxTgt_Inter_Exp_Pval <0.2,TRUE,FALSE)
predicted_resistance_mut= ifelse(
out.MutantTarget$MaxTgt_Inter_Mut_Pval<0.1,TRUE,FALSE)


## ----Preparation for Output---------------------------------------------------
Pred.d <- NULL;
Pred.d <- cbind(DrugTarcomputeCor,DrugGeneMaxSim,out.MutantTarget,predicted_resistance_mut)
mutant.C <- vapply(Pred.d[,3],function(x)tryCatch(sum(d.mt[x,] ==1),error=function(e){NA}),FUN.VALUE = length(Pred.d[,3]))
Pred.d$mutant.C <- mutant.C
Low.Exp.C = vapply(Pred.d[,3],
function(x)tryCatch(sum(d.expr[x,] < 2),error=function(e){NA}),FUN.VALUE = length(Pred.d[,3]))
Pred.d <- cbind(Pred.d, out.LowexpTarget, Whether_interaction_Ex_based,Low.Exp.C)


## ----Identifying Drugs with low primary target expressing cell lines----------
Low.i <- which(Pred.d$Low.Exp.C >5)
Pred.d.f <- Pred.d[ Low.i,]
Low.Exp.G <- NULL;
for (i in 1:nrow(Pred.d.f)){
    Gene.i <- Pred.d.f[,3][i]
    Temp <- tryCatch(names(which(d.expr[Gene.i,]<2)),error=function(e){NA})
    Low.Exp.G [[length(Low.Exp.G) + 1]] <- Temp
}
names(Low.Exp.G) <- Pred.d.f[,3]
sim.LowExp <- NULL;
sec.prism.f.f <- sec.prism.f[Low.i,]
identical (row.names(sec.prism.f.f) ,Pred.d.f[,1])


## ----Calculating Drug KO Similarities in cell lines with low primary target----
for (i in 1:nrow(Pred.d.f)){
    DRS.L= sec.prism.f.f[i,Low.Exp.G[[unlist(Pred.d.f[i,3])]]]
    DRS.L <- t(as.data.frame(DRS.L))
    row.names(DRS.L) <- Pred.d.f[i,1]
    out <- computeCor(Pred.d.f[i,1],DRS.L,KO.GES)
    sim.LowExp [[length(sim.LowExp) + 1]] <- out
}
names(sim.LowExp) <- Pred.d.f[,1]


## ----Finding a primary target-------------------------------------------------
## This drug is unique in this Prediction data object.
DOI = 'AMG-232'
GOI = 'MDM2'
plotCor(DOI,GOI,Pred.d,sec.prism.f,KO.GES,plot=TRUE)
## Interpretation: The graph shows that there is a positive significant 
## correlation of MDM2 with drug AMG-232 (Correlation value: 0.54 
## and P val < 0.01)
DOI = 'dabrafenib'
GOI = 'BRAF'
## this drug has duplicated assay; which is row 4 and 5 in both Pred.d object and drug treatment.
## Here, let's look at the row 5 obtain the drug response for 'dabrafenib'
DRS <- as.data.frame(sec.prism.f[5,])
DRS <- t(DRS)
## set the rownames with the Broad ID of the DOI
row.names(DRS) <- row.names(sec.prism.f)[5]
identical ( Pred.d$DrugID, row.names(sec.prism.f))
## because the Pred.d and sec.prism.f have the same orders so we
plotCor(DOI,GOI,Pred.d[5,],DRS,KO.GES,plot=TRUE)
## Interpretation: The graph shows that there is a positive significant 
## correlation of BRAF with drug dabrafenib. (Correlation value(R): 0.58 and P val < 0.01)

## ----Predicting whether the drug specifically targets the wild-type or mutated target forms----
## preparing the data for mutation from Pred.d dataframe.
Pred.d.f <- Pred.d[,c(1:3,12:15)]
## only look at the mutated target forms.
Pred.d.f.f <- Pred.d.f[which (Pred.d.f$predicted_resistance_mut==TRUE), ]
## Let's start with CGM097, unique assay in row 3
DOI=Pred.d.f.f$drugName[3]
GOI=Pred.d.f.f$MaxTargetName[3]
DrugID <- Pred.d.f.f$DrugID[3]
DRS=as.data.frame(sec.prism.f[DrugID,])
DRS <- t(DRS)
row.names(DRS) <- DrugID
# let's take a look at the initial 5 outcomes pertaining to the first drug.
DRS[1,1:5]
out <- DMB(DOI,GOI,Pred.d.f.f[3,],d.mt,DRS,KO.GES,plot=TRUE)
print (out)
## Interpretation: The graph shows CGM097 is likely targeting both the mutant 
## form (R=0.81, P val <0.01) and the wild type form (R=0.49, P >0.01) of 
## the MDM2 gene.
## For dabrafenib, both assays suggest that BRAF is mutated target forms, we will choose one for visualization.
DOI ="dabrafenib"
GOI = "BRAF"
# because this has two assays in the drug response score matrix, we will visualize one of them.
# first check identity.
identical ( Pred.d.f$DrugID, row.names(sec.prism.f))
## we will choose the row 5.
DRS <- as.data.frame(sec.prism.f[5,])
DRS <- t(DRS)
row.names(DRS) <- row.names(sec.prism.f)[5]
out <- DMB(DOI,GOI,Pred.d.f[5,],d.mt,DRS,KO.GES,plot=TRUE)
print (out)
## Interpretation: The graph shows dabrafenib is likely targeting the mutant 
## form (R=0.66, P val <0.01) rather than the wild type form (R=-0.1, P >0.01) 
## of BRAF gene.


## ----Predicting secondary target----------------------------------------------
## This drug has two assays.
# The index is 14 in the order of the interesting drugs.
identical (Pred.d$DrugID, row.names(sec.prism.f))
DRS <- as.data.frame(sec.prism.f[14,])
DRS <- t(DRS)
row.names(DRS) <- row.names(sec.prism.f)[14]
####
DOI="ibrutinib"
GOI="BTK"
out <- DTR (DOI,GOI,Pred.d[14,],d.expr,DRS,KO.GES,CutOff= 2)
print(out)


## ----Predicting secondary target(s) that mediate its response when the primary target is not expressed----

sim.LowExp.Strength=vapply(sim.LowExp, function(x) x[,2],FUN.VALUE = numeric(nrow(sim.LowExp[[1]])))
dim(sim.LowExp.Strength)
sim.LowExp.Pval=vapply(sim.LowExp, function(x) x[,1], FUN.VALUE = numeric(nrow(sim.LowExp[[1]])))
head(sim.LowExp.Pval)
## Let's take a look at ibrutinib
par(mar=c(4,4,5,2), xpd=TRUE, mfrow=c(1,2));
plotSim(sim.LowExp.Pval[,8],sim.LowExp.Strength[,8],colorRampPalette(c("lightblue",'darkblue')),plot=TRUE)


## ----Conclusion---------------------------------------------------------------
DOI="ibrutinib"
GOI="EGFR"
out <- DTR (DOI,GOI,Pred.d[14,],d.expr,DRS,KO.GES,CutOff= 2)
print (out)


## ----session------------------------------------------------------------------
sessionInfo()

## Function to plot the similarity based on correlation values and p values.
plotSim <- function(dx,dy,clr=NULL, plot=TRUE){
    if (is.null(clr)){ clr <- colorRampPalette(c("lightblue",'darkblue'))}
    dx <- as.matrix(dx)
    dy <- as.matrix(dy)
    if (plot) {
        if (identical(dimnames(dx), dimnames(dy))){
            for ( i in seq_len(ncol(dx))){
                x <- -log10 (dx[,i])
                y <- dy[,i]
                top.5 <- names (sort(dy[,i], decreasing=TRUE)[seq_len(5)])
                y.clr <- clr(10)[as.numeric(cut(y,breaks = 10))]
                x1   <- (min(x) + max(x))/2 - 2;
                x2   <- (min(x) + max(x))/2 + 2;
                y1   <- max(y) + (min(abs(y)) + max(abs(y))) * 0.40;
                y2   <- max(y) + (min(abs(y)) + max(abs(y))) * 0.55;
                plot(x, y, pch = 19, col = y.clr , 
                    xlab="-log10(Pval)",
                    ylab= paste0("correlation strength ",colnames(dx)[i]));
                text(x[top.5],  y [top.5],  top.5,cex=0.65, pos=2.8,col="black")
                colorBar(x1, y1, x2, y2, v.min=min(y),
                    v.max=max(y),col.l=clr(100))
            }
        }else{
            stop("the dimension of input is not the same, please double check")}
    }
}

## Function to generate a correlation plot for a target.
plotCor <- function(DN,GN,Pred,DRS,GES,plot=TRUE){
    if (nrow (Pred)==0) {stop("Pred should contain drug of interest")}
    L.c <- list( KO= colnames(GES),Drug_Prism= colnames(DRS))
    CL.M <- Reduce(intersect,L.c)
    if ( DN %in% Pred[,2]){
        if (plot){
            GES.c <- GES [GN,CL.M]
            DRS.c <- DRS[Pred[DN,1],CL.M]
            dat.c <- data.frame(GES.c,DRS.c)
            ggplot(dat.c, aes(x = GES.c, y = DRS.c))+
                geom_point()+
                stat_smooth(method = 'lm')+
                theme_bw(base_size = 15)+
                labs(x = paste0(GN,'_Viability after CRISPR-KO'), 
                y = paste0('Response to ', Pred[DN,2]))+
                stat_cor(label.y = c(1.3,1.4))}
    }else{
        stop("The drug of interest doesn't existed. Please double check.")
    }
}

## Function to calculate the WT target interaction based on a cut-off value.
DoInteractExp <- function(Predtargets,Exp,DRS,GES,CutOff=3 ){
    L.c <- list(
        KO= colnames(GES),Drug_Prism= colnames(DRS),Expr= colnames(Exp))
    CL.M <- Reduce(intersect,L.c)
    interactFeatures <- lapply(seq_len(nrow(Predtargets)), function(x){
    ## Drug response based on the drug ID
    DRS.f <- tryCatch(DRS[Predtargets[x,1],CL.M],error=function(e){NA})
    ## Gene effect scores based on the targeted gene
    GES.f <- tryCatch(GES[Predtargets[x,3],CL.M],error=function(e){NA})
    ## Groups based on the cut-off gene expression
    Exp.Group <- tryCatch(Exp[Predtargets[x,3],CL.M]< CutOff,
        error=function(e){NA})
    ## True is low, False is high.
    tryCatch(summary(lm(DRS.f ~ GES.f * Exp.Group))$coefficients[4,c(1,4)],
        error=function(e){NA})})
    names(interactFeatures) <- Predtargets$drugName
    interactFeatures
}

## Function to calculate Drug Target Response (DTR).
DTR <- function(DN,GN,Pred,Exp,DRS,GES,CutOff=3,plot=TRUE ){
    if (nrow (Pred)==0) {stop("Pred should contain drug of interest")}
    L.c <- list(
        KO= colnames(GES),Drug_Prism= colnames(DRS),Expr= colnames(Exp))
    CL.M <- Reduce(intersect,L.c)
    if ( DN %in% Pred[,2]){
        if (plot){
            exp.g <- Exp[GN,CL.M]< CutOff
            ## True is low, False is high
            exp.g  <- factor(exp.g);
            colcode <- exp.g
            levels(colcode) <- c('High', 'Low')
            dat.c <- data.frame(
                GES.c = GES[GN,CL.M],
                DRS.c = DRS[Pred[DN,1],CL.M],
                Expr.c = colcode)
            ggplot(dat.c, 
                aes(x = dat.c[,1], y = dat.c[,2], color = factor(dat.c[,3])))+
                stat_smooth(method = 'lm')+
                theme_bw(base_size = 15)+
                labs(x = 'Viability after Cripspr Knockout', 
                    y = paste0('Response to ',Pred[DN,2]),
                    color =  paste0(GN,'\nExpression\nstatus'))+
                    stat_cor(label.y = c(1.3,1.4))}
    }else{
        stop("The drug of interest does not exist. Please double check")}
}

## Function to calculate the interaction for a mutant target
DoInteractMutant <- function(Predtargets,Mutant,DRS,GES){
    # Retrieve only the overlapping samples
    L.c <- list( KO= colnames(GES),
                Drug_Prism= colnames(DRS),
                Mutation= colnames(Mutant))
    CL.M <- Reduce(intersect,L.c)
    interactFeatures <- lapply(seq_len(nrow(Predtargets)), function(x){
            ##  Drug response scores (DRS) based on the drug ID
            DRS.f <- tryCatch(DRS[Predtargets[x,1],CL.M],error=function(e){NA})
            ## Gene effect scores (GES) based on the targeted gene
            GES.f <- tryCatch(GES[Predtargets[x,3],CL.M],
                error=function(e){NA})
            Mutant.Group <- tryCatch(Mutant[Predtargets[x,3],CL.M] )
            ## True is low, False is high.
            tryCatch(summary(
                lm(DRS.f ~ GES.f * Mutant.Group))$coefficients[4,c(1,4)],
                error=function(e){NA})
            })
    names(interactFeatures) <- Predtargets$drugName
    interactFeatures
}

---
title: "Workflow Demonstration for Deep characterization of cancer drugs"
output: 
  BiocStyle::html_document
date: "`r Sys.Date()`"
vignette: >
  %\VignetteIndexEntry{Workflow Demonstration for Deep characterization of cancer drugs}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  markdown: 
    wrap: 72
---

```{r, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    warning = FALSE,
    message = FALSE,
    cache = TRUE
)
```

# Introduction

This vignette will guide users how to integrate large-scale genetic and
drug screens to do association analysis and use this information to both
predict the drug's primary target(s) or secondary target and investigate
whether the primary target specifically targets the wild-type or mutated
target forms. This will be done by three parts: Core Analysis, and
application, and conclusion. The result from core analysis will be used for the
application part. We also give an example for interpreting the result in
the conclusion part.

# Part I: Core Analysis

The core analysis includes loading the necessary data, performing the
core analysis, and saving the results. Specifically, for a given drug,
the core analysis includes generating a similarity score between the
viability after drug treatment and each gene knockout,and computing if
the drug may differential bind to the known drug target mutant form or
WT form, by calculating this similarity in cell lines with known target
WT vs. mutant form, and finally, finding the secondary targets of the
drug by repeating this analysis in the cell lines where the primary
target is not expressed.

Below is the step-by-step scripts for this Core analysis part:

## Data Loading and Preparation
Users can use the Depmap2DeepTarget function to obtain the data needed. 
Please note that you are required to agree to the terms and conditions of 
DepMap portal (https://depmap.org/portal/). Some of these terms and conditions 
are problematic for U.S. Federal Government employees, and they should consult their technology transfer office/legal office before agreeing to such terms and conditions. 
Here, the script loads OntargetM object and prepare the matrices for the drug response scores (secondary_prism ) and CRISPR Gene Effect scores. We will use these two matrices to obtain the correlation information. This OntargetM object only contains a small subset of data across common cell lines for demonstration purpose.


secondary_prism: row names is the drug ID and column names are cell
lines. The values are the response scores. 
avana_CRISPR: row names are the gene's names and column are cell lines. The values are the effect scores of KO method.

```{r Data Loading and Preparation}

library(DeepTarget)
data("OntargetM")
## "Below is the OnTargetM object containing a subset of public data downloading from depmap.org"
vapply(OntargetM,dim,FUN.VALUE = numeric(2))
## drug of interest.
drug.name <- c('atiprimod','AMG-232','pitavastatin','Ro-4987655','alexidine','RGFP966','dabrafenib','olaparib','CGM097','ibrutinib','palbociclib')
## data preparation for these drugs
## the secondary prism contain the response scores, where columns are cell lines and row names for Broad IDs of the drug.
## First, Obtain the broad ID for these interesting drug.
Broad.IDs <- OntargetM$DrugMetadata$broad_id_trimmed[which(OntargetM$DrugMetadata$name %in% drug.name)]
## the drug response has duplicated assays so we have 16 rows returned for 11 drugs.
sec.prism.f <- OntargetM$secondary_prism[which ( row.names(OntargetM$secondary_prism) %in% Broad.IDs), ]
KO.GES <- OntargetM$avana_CRISPR

```

## Computing Similarity Between Drug Treatment and Gene Knockout

The script computes the similarity Between Drug Treatment and Gene
Knockout using computeCor function. We assign the correlation values as
similarity scores.

Input: Drug Response Scores (DRS) and Knock-out Gene Expression Scores
from CRIPSR method ( KO.GES). Output: a list of ID drugs where each drug
contains a matrix of their correlation, p val, and FDR values.

```{r Computing a correlation between the every gene crispr KO vs each drug response for all interesting drugs}
List.sim <- NULL;
for (i in 1:nrow(sec.prism.f)){
    DRS <- as.data.frame(sec.prism.f[i,])
    DRS <- t(DRS)
    row.names(DRS) <- row.names(sec.prism.f)[i]
    out <- computeCor(row.names(sec.prism.f)[i],DRS,KO.GES)
    List.sim [[length(List.sim) + 1]] <- out
}
names(List.sim) <- row.names(sec.prism.f)

```

## Predicting Similarity Across Known Targeted Genes and All Genes

The script predicts similarity Across Known Targeted Genes and All Genes
using PredTarget and PredMaxSim functions. 
Input: List.sim: the list of similarity scores obtained above.
meta data: drug information.
Output:
PredTarget(): a data frame contain the drug name and the max similarity
scores among their targeted proteins. For example, if there are two
proteins targeted for the same drug, the one has higher correlation will
be likely the most targeted for that drug. 
PredMaxSim (): a data frame
contain the drug name and the protein with the max similarity scores
across all genes. For example, within a drug, the protein A with the
highest similarity score will be assigned as best target for that drug.

```{r section.cap="Predicting Similarity Across Known Targeted Genes and All Genes"}
metadata <- OntargetM$DrugMetadata
DrugTarcomputeCor <- PredTarget(List.sim,metadata)
DrugGeneMaxSim <- PredMaxSim(List.sim,metadata)

```

## Computing the Interaction

The script computes the interaction between the drug and knockout (KO)
gene expression in terms of both mutant vs non-mutant and lower vs
higher expression using DoInteractExp function and DoInteractMutant
function. 
Input: Mutation matrix, expression matrix, drug response scores. 
    Mutation matrix: row names are gene names and column names are
    cell lines. The values are mutant or non mutant (0 and 1) 
    Expression matrix: row names are gene names and column names are cell lines.
    The values are gene expression. 
    Drug response scores: The output from PredTarget(). We only focus on 
    learning more about the interaction of these drugs with their best targets. 
output:
DoInteractMutant(): a data frame contains the
drug name and their strength from linear model function from drug
response and gene expression scores in term of mutant/non-mutant group.

DoInteractExp(): a data frame contains the drug name and their strength
from linear model function from drug response and gene expression scores
in term of expression group based on cut-off values from expression values.
```{r section.cap="Computing the Interaction"}
d.mt <- OntargetM$mutations_mat
d.expr <- OntargetM$expression_20Q4
out.MutantTarget <- NULL;
out.LowexpTarget <- NULL;
for (i in 1:nrow(sec.prism.f)){
    DRS=as.data.frame(sec.prism.f[i,])
    DRS <- t(DRS)
    row.names(DRS) <- row.names(sec.prism.f)[i]
    ## for mutant
    Out.M <- DoInteractMutant(DrugTarcomputeCor[i,],d.mt,DRS,KO.GES)
    TargetMutSpecificity <- data.frame(MaxTgt_Inter_Mut_strength=vapply(Out.M, function(x)  x[1],numeric(1)), MaxTgt_Inter_Mut_Pval=vapply(Out.M, function(x) x[2],numeric(1)))
    out.MutantTarget <- rbind(out.MutantTarget,TargetMutSpecificity)
    ## for expression.
    Out.Expr <- DoInteractExp(DrugTarcomputeCor[i,],d.expr,DRS,KO.GES,CutOff= 2)
    TargetExpSpecificity <- data.frame(
    MaxTgt_Inter_Exp_strength <- vapply(Out.Expr, function(x) x[1],numeric(1)),
    MaxTgt_Inter_Exp_Pval <- vapply(Out.Expr, function(x) x[2],numeric(1)))
    out.LowexpTarget <- rbind (out.LowexpTarget,TargetExpSpecificity)
}

```

## Interaction Assessment

This part of the script assesses whether the interaction result is true
or false based on a certain cut-off, and the p-value from the above
part.

```{r Interaction Assessment}
Whether_interaction_Ex_based= ifelse( out.LowexpTarget$MaxTgt_Inter_Exp_strength <0
& out.LowexpTarget$MaxTgt_Inter_Exp_Pval <0.2,TRUE,FALSE)
predicted_resistance_mut= ifelse(
out.MutantTarget$MaxTgt_Inter_Mut_Pval<0.1,TRUE,FALSE)

```

## Preparation for Output

Lastly, the script gathers the results into a final data frame and
writes it to a CSV file to be used for the application part.

```{r Preparation for Output}
Pred.d <- NULL;
Pred.d <- cbind(DrugTarcomputeCor,DrugGeneMaxSim,out.MutantTarget,predicted_resistance_mut)
mutant.C <- vapply(Pred.d[,3],function(x)tryCatch(sum(d.mt[x,] ==1),error=function(e){NA}),FUN.VALUE = length(Pred.d[,3]))
Pred.d$mutant.C <- mutant.C
Low.Exp.C = vapply(Pred.d[,3],
function(x)tryCatch(sum(d.expr[x,] < 2),error=function(e){NA}),FUN.VALUE = length(Pred.d[,3]))
Pred.d <- cbind(Pred.d, out.LowexpTarget, Whether_interaction_Ex_based,Low.Exp.C)

```

## In addition to the output of prediction object, we also identify drugs with low primary target expressing cell lines

For the drugs where the primary target is not expressed in at least five
cell lines, we will identify their secondary target below. This section
identifies primary target genes that are not expressed in at least 5
cell lines.

```{r Identifying Drugs with low primary target expressing cell lines}
Low.i <- which(Pred.d$Low.Exp.C >5)
Pred.d.f <- Pred.d[ Low.i,]
Low.Exp.G <- NULL;
for (i in 1:nrow(Pred.d.f)){
    Gene.i <- Pred.d.f[,3][i]
    Temp <- tryCatch(names(which(d.expr[Gene.i,]<2)),error=function(e){NA})
    Low.Exp.G [[length(Low.Exp.G) + 1]] <- Temp
}
names(Low.Exp.G) <- Pred.d.f[,3]
sim.LowExp <- NULL;
sec.prism.f.f <- sec.prism.f[Low.i,]
identical (row.names(sec.prism.f.f) ,Pred.d.f[,1])

```

## Calculating Drug KO Similarities in cell lines with low primary target

The following script performs calculations to determine DKS score in
cell lines with low primary target expression. This DKS score is called
Secondary DKS Score and denotes the secondary target probability.

```{r Calculating Drug KO Similarities in cell lines with low primary target}
for (i in 1:nrow(Pred.d.f)){
    DRS.L= sec.prism.f.f[i,Low.Exp.G[[unlist(Pred.d.f[i,3])]]]
    DRS.L <- t(as.data.frame(DRS.L))
    row.names(DRS.L) <- Pred.d.f[i,1]
    out <- computeCor(Pred.d.f[i,1],DRS.L,KO.GES)
    sim.LowExp [[length(sim.LowExp) + 1]] <- out
}
names(sim.LowExp) <- Pred.d.f[,1]

```

# Part II: Application

For this section, we will use the information obtained above. 
First, we find a drug's primary target(s) and visualize them.
Next, we predict whether the drug specifically targets the wild-type or
mutated target forms. We then predict the secondary target(s) that
mediate its response when the primary target is not expressed. For more
detail, please refer to the paper from this link:
<https://www.biorxiv.org/content/10.1101/2022.10.17.512424v1>

## Finding and visualizing a drug primary target

The script below generates the correlation plots for primary targets BRAF
and MDM2 for the drugs Dabrafenib and AMG-232 respectively.

```{r Finding a primary target}
## This drug is unique in this Prediction data object.
DOI = 'AMG-232'
GOI = 'MDM2'
plotCor(DOI,GOI,Pred.d,sec.prism.f,KO.GES,plot=TRUE)
## Interpretation: The graph shows that there is a positive significant 
## correlation of MDM2 with drug AMG-232 (Correlation value: 0.54 
## and P val < 0.01)
DOI = 'dabrafenib'
GOI = 'BRAF'
## this drug has duplicated assay; which is row 4 and 5 in both Pred.d object and drug treatment.
## Here, let's look at the row 5 obtain the drug response for 'dabrafenib'
DRS <- as.data.frame(sec.prism.f[5,])
DRS <- t(DRS)
## set the rownames with the Broad ID of the DOI
row.names(DRS) <- row.names(sec.prism.f)[5]
identical ( Pred.d$DrugID, row.names(sec.prism.f))
## because the Pred.d and sec.prism.f have the same orders so we
plotCor(DOI,GOI,Pred.d[5,],DRS,KO.GES,plot=TRUE)
## Interpretation: The graph shows that there is a positive significant 
## correlation of BRAF with drug dabrafenib. (Correlation value(R): 0.58 and P val < 0.01)
```

## Predicting whether the drug specifically targets the wild-type or mutated target forms

The script below shows whether the drugs, CGM097 and Dabrafenib, target
the wild-type or mutated target forms of MDM2 and BRAF respectively from
the Prediction object and then generates plots for visualization.

```{r Predicting whether the drug specifically targets the wild-type or mutated target forms}
## preparing the data for mutation from Pred.d dataframe.
Pred.d.f <- Pred.d[,c(1:3,12:15)]
## only look at the mutated target forms.
Pred.d.f.f <- Pred.d.f[which (Pred.d.f$predicted_resistance_mut==TRUE), ]
## Let's start with CGM097, unique assay in row 3
DOI=Pred.d.f.f$drugName[3]
GOI=Pred.d.f.f$MaxTargetName[3]
DrugID <- Pred.d.f.f$DrugID[3]
DRS=as.data.frame(sec.prism.f[DrugID,])
DRS <- t(DRS)
row.names(DRS) <- DrugID
# let's take a look at the initial 5 outcomes pertaining to the first drug.
DRS[1,1:5]
out <- DMB(DOI,GOI,Pred.d.f.f[3,],d.mt,DRS,KO.GES,plot=TRUE)
print (out)
## Interpretation: The graph shows CGM097 is likely targeting both the mutant 
## form (R=0.81, P val <0.01) and the wild type form (R=0.49, P >0.01) of 
## the MDM2 gene.
## For dabrafenib, both assays suggest that BRAF is mutated target forms, we will choose one for visualization.
DOI ="dabrafenib"
GOI = "BRAF"
# because this has two assays in the drug response score matrix, we will visualize one of them.
# first check identity.
identical ( Pred.d.f$DrugID, row.names(sec.prism.f))
## we will choose the row 5.
DRS <- as.data.frame(sec.prism.f[5,])
DRS <- t(DRS)
row.names(DRS) <- row.names(sec.prism.f)[5]
out <- DMB(DOI,GOI,Pred.d.f[5,],d.mt,DRS,KO.GES,plot=TRUE)
print (out)
## Interpretation: The graph shows dabrafenib is likely targeting the mutant 
## form (R=0.66, P val <0.01) rather than the wild type form (R=-0.1, P >0.01) 
## of BRAF gene.

```

## Predicting secondary target(s) that mediate its response when the primary target is not expressed

As an example, let's look at the drug 'ibrutinib' from the Prediction
object. Ibrutinib is a well-known covalent target of BTK. Please note
that for this drug, there are two assays. We selected only one of them for
this example.

```{r Predicting secondary target}
## This drug has two assays.
# The index is 14 in the order of the interesting drugs.
identical (Pred.d$DrugID, row.names(sec.prism.f))
DRS <- as.data.frame(sec.prism.f[14,])
DRS <- t(DRS)
row.names(DRS) <- row.names(sec.prism.f)[14]
####
DOI="ibrutinib"
GOI="BTK"
out <- DTR (DOI,GOI,Pred.d[14,],d.expr,DRS,KO.GES,CutOff= 2)
print(out)

```

We find above that Ibrutinib's response is only correlated with the BTK
gene in cell lines where BTK is expressed and not in cell lines where
BTK is not expressed. Next, let's look at the correlation between the
BTK gene KO and this drug response in no BTK cell lines to predict the
secondary targets for this drug.

```{r Predicting secondary target(s) that mediate its response when the primary target is not expressed}

sim.LowExp.Strength=vapply(sim.LowExp, function(x) x[,2],FUN.VALUE = numeric(nrow(sim.LowExp[[1]])))
dim(sim.LowExp.Strength)
sim.LowExp.Pval=vapply(sim.LowExp, function(x) x[,1], FUN.VALUE = numeric(nrow(sim.LowExp[[1]])))
head(sim.LowExp.Pval)
## Let's take a look at ibrutinib
par(mar=c(4,4,5,2), xpd=TRUE, mfrow=c(1,2));
plotSim(sim.LowExp.Pval[,8],sim.LowExp.Strength[,8],colorRampPalette(c("lightblue",'darkblue')),plot=TRUE)

```

# Part III: Conclusion

We observe below that Ibrutinib response is strongly correlated with
EGFR knockout (KO) in cell lines where Bruton tyrosine kinase (BTK) is
not expressed. However, this correlation is not observed in cell lines
where BTK is expressed. Among the top predicted genes, there are more
layers of evidence that Ibrutinib binds physically to EGFR. Thus, let's
focus further on EGFR.

```{r Conclusion}
DOI="ibrutinib"
GOI="EGFR"
out <- DTR (DOI,GOI,Pred.d[14,],d.expr,DRS,KO.GES,CutOff= 2)
print (out)

```

# Session info

```{r session}
sessionInfo()
```

\name{DTR}
\alias{DTR}
\title{
Predicting Drug Target Response (DTR) for primary or secondary targets
}
\description{
Predicting whether the drug is likely response to primary or secondary targets and also generates the plot for visualization.
}
\usage{
DTR(DN,GN,Pred,Exp,DRS,GES,CutOff= 3,plot = TRUE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
    \item{DN}{Drug of interest}
    \item{GN}{Gene of interest}
    \item{Pred}{Prediction object, an output result from prediction whether it is a primary target or secondary target}
    \item{Exp}{Expression matrix}
    \item{DRS}{Drug response matrix}
    \item{GES}{Gene Effect Scores}
    \item{plot}{whether users want to plot, default is true}
    \item{CutOff}{cutoff value for gene expression of gene of interest high or low}
}
\value{vialbility after KO vs drug response of gene of interest low vs high cut-off values set by users}
\author{sanjusinha7, Trinh Nguyen}
\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
S.Drugs <- c('K70301465','K09951645')
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
d.expr <- OntargetM$expression_20Q4
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim.out,Meta.data)
Drug.Gene.max.sim <- PredMaxSim(sim.out,Meta.data)
identical ( DrugTargetSim[,1],Drug.Gene.max.sim[,1] )
Pred.d <-cbind (DrugTargetSim,Drug.Gene.max.sim )
DOI = 'ibrutinib'
GOI ='BTK'
DTR(DOI,GOI,Pred.d,d.expr,sec.prism,KO.GES,CutOff= 2)
}

\name{plotCor}
\alias{plotCor}
\title{
Plot the correlation
}
\description{
Plot the correlation of a predicted target
}
\usage{
plotCor(DN,GN,Pred,DRS,GES,plot=TRUE)
}
\arguments{
    \item{DN}{Drug Name}
    \item{GN}{Gene Name}
    \item{Pred}{Output from prediction object}
    \item{DRS}{Drug response score}
    \item{GES}{Gene Effect scores}
    \item{plot}{ default is plot=TRUE}
}
\value{Correlation plot}
\author{
sanjusinha7, Trinh Nguyen
}
\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
S.Drugs <- c('K70301465','K09951645')
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
d.expr <- OntargetM$expression_20Q4
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim.out,Meta.data)
Drug.Gene.max.sim <- PredMaxSim(sim.out,Meta.data)
identical ( DrugTargetSim[,1],Drug.Gene.max.sim[,1] )
Pred.d <-cbind (DrugTargetSim,Drug.Gene.max.sim )
DOI = 'ibrutinib'
GOI ='BTK'
plotCor (DOI,GOI,Pred.d,sec.prism,KO.GES)
}

\name{PredTarget}
\alias{PredTarget}
\title{
Prediction  of the most similar known targeted gene.
}
\description{
Predicts the gene that has the most similarity to a drug’s response scores. This is done based on selecting a gene that has the most correlation across the known targeted genes by their drug.
}
\usage{
PredTarget(Sim.GES.DRS,D.M)
}
\arguments{
    \item{Sim.GES.DRS}{similarity between Drug’s response scores and Gene effect scores from Knock-out method such as CRISPR.}
    \item{D.M}{Drug Metadata}
}
\value{
a dataframe of drug(s) information with the most known predicted gene(s) with the max corelation value(s), P value(s), and FDR value(s).
}
\author{
sanjusinha7, Trinh Nguyen
}
\examples{
library(BiocParallel)
data(OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
S.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim.out,Meta.data)
}

\name{OntargetM}
\alias{OntargetM}
\docType{data}
\title{An object containing a small part of the data from the Cancer Dependency Map (depmap.org) to demonstrate in DeepTarget pipeline}
\description{
An object containing Viability matrix after CRISPR-KO; Viability after Drug Treatment; Drug metadata from Broad, mutation matrix, and expression matrix with common cell-lines and common drugs. This is a subset of the total data due to memory constraints, full data can be downloaded from depmap.org/portal.
}
\usage{data("OntargetM")}
\format{A list of one dataframe and 4 matrices
    \describe{
        \item{\code{DrugMetadata}}{a dataframe containing 11 unique drugs as rownames with their associated information:  broad_id_trimmed as ID of the drug, name, target, drug_category, and moa as columns}
        \item{\code{secondary_prism}}{a viability scores matrix (after Drug Treatment) with 16 drugs as row names across 392 unique celllines as column names}
        \item{\code{avana_CRISPR}}{a Gene effect scores (after CRISPR-KO) matrix for 487 genes as row names across 392 unique celllines as column names}
        \item{\code{mutations_mat}}{Mutation binary matrix for 476 genes as row names across 392 unique cell lines as column names; 0 is WT; 1 is mutated}
        \item{\code{expression_20Q4}}{ Expression matrix for  550 genes as row names across 392 unique celllines as column names}
    }
}
\details{
For a full list data used in the paper, please use the link below to download data
}
\source{
DrugMetadata: Please download full data from this link \url{ https://depmap.org/repurposing/#:~:text=Corsello_supplemental_tables.xlsx}

Secondary prism: please download full data from this link \url{https://depmap.org/portal/download/all/?releasename=PRISM+Repurposing+19Q4&filename=secondary-screen-dose-response-curve-parameters.csv}

avana_CRISPR: please download full data from this link \url{https://depmap.org/portal/download/all/?releasename=DepMap+Public+22Q4&filename=CRISPRGeneEffect.csv}

mutations_mat:  Please download full data from this link \url{https://depmap.org/portal/download/all/?releasename=DepMap+Public+22Q4&filename=OmicsSomaticMutations.csv}

expression_20Q4: Please download full data of file named "CCLE_expression.csv" from this link \url{https://depmap.org/portal/download/all/}

}
\examples{
data(OntargetM)
}
\keyword{datasets}

\name{DoInteractMutant}
\alias{DoInteractMutant}
\title{
Compute interaction between the drug and KO expression in term of mutant vs non-mutant
}
\description{
Compute interaction between the drug and KO expression in term of mutant vs non-mutant
}
\usage{
DoInteractMutant(Predtargets,Mutant,DRS,GES)
}

\arguments{
    \item{Predtargets}{a dataframe of drugs information and their most targeted gene with stats of correlation}
    \item{Mutant}{Mutant matrix}
    \item{DRS}{Drug scores matrix}
    \item{GES}{Gene effect scores matrix from KO method}
}
\value{
A list of drug names with their interaction values from two groups mutant and non-mutant
    \item{drug1 }{interaction with estimate and P vals from the linear model}
    \item{drug2 }{interaction with estimate and P vals from the linear model}
    \item{drugN }{interaction with estimate and P vals from the linear model}
}
\author{sanjusinha7, Trinh Nguyen}
\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
S.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim,Meta.data)
d.mt <- OntargetM$mutations_mat
MutantInteract <- DoInteractMutant (DrugTargetSim,d.mt,sec.prism,KO.GES)
}

\name{Depmap2DeepTarget}
\alias{Depmap2DeepTarget}
\title{
Retrieval and preparation of input data required from Depmap to Deeptarget package.
}
\description{
Retrieve gene expression, Cripr, mutation data from KO method, and drug matrix and then preperation the matrix compatible as input for Deeptarget.
}
\usage{
Depmap2DeepTarget(FileN,version)
}
\arguments{
    \item{FileN}{File Named used as input for DeepTarget: "CCLE_expression.csv", "CRISPRGeneEffect.csv"    ,"OmicsSomaticMutations.csv", or "secondary-screen-dose-response-curve-parameters.csv"}
    \item{version}{Version of data}
}
\value{
a data frame for each required input data
}
\author{
Trinh Nguyen, Ying Hu, and sanju
}

\examples{
library(readr)
library(depmap)
# expresion
CCLE.exp <- Depmap2DeepTarget("CCLE_expression.csv","19Q4")
}

\name{DMB}
\alias{DMB}
\title{ Predicting Drug Mutant Binding for mutant or non-mutant form}
\description{
Predicting whether the drug is likely bind to mutant or non-mutant form and also generates the plot for visualization.
}
\usage{
DMB(DrugName,GOI,Pred,Mutant,DRS,GES,plot=TRUE)
}
\arguments{
    \item{DrugName}{Drug of interest}
    \item{GOI}{Gene of interest}
    \item{Pred}{Prediction object resulting from both PredTarget and PredMaxSim functions to predict whether it is a primary target or secondary target}
    \item{Mutant}{Mutant matrix}
    \item{DRS}{Drug response matrix}
    \item{GES}{Gene Effect Scores}
    \item{plot}{Default is TRUE for plotting}
}
\value{
The plot of viability after KO as the X-axis vs drug response in a mutant target as the Y-axis.
}
\author{
sanjusinha7, Trinh Nguyen
}
\examples{
library(BiocParallel)
data (OntargetM)
S.Drugs <- c('K70301465','K09951645')
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
d.mt <- OntargetM$mutations_mat
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim.out,Meta.data)
Drug.Gene.max.sim <- PredMaxSim(sim.out,Meta.data)
identical ( DrugTargetSim[,1],Drug.Gene.max.sim[,1])
Pred.d <-cbind (DrugTargetSim,Drug.Gene.max.sim)
DOI = 'dabrafenib'
GOI = 'BRAF'
DMB (DOI,GOI,Pred.d,d.mt,sec.prism,KO.GES)
}

\name{computeCor}
\alias{computeCor}
\title{Compute a correlation between the every gene vs each drug response}
\description{
Compute correlations between the viability of cell lines after CRISPR Knock Out of each gene and of the same cell lines after drug treatment.
}
\usage{computeCor(DrugName,DRS,GES)}
\arguments{
    \item{DrugName}{Drug Name}
    \item{DRS}{Drug’s response scores}
    \item{GES}{Gene effect scores from Knock-out method such as CRISPR.}
}
\value{
a list of matrices for the interesting drugs, where each matrix containing gene names with the correlation values and P values associated with response scores from a given drug ID.
}
\author{
sanjusinha7, Trinh Nguyen
}
\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
S.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out ) <- S.Drugs
head(sim.out)
}

\name{plotSim}
\alias{plotSim}
\title{
Plot the similarty between corelation values and P vals for all genes. The top 5 genes are labeled.
}
\description{
Plot the similarty between corelation values and P val;
}
\usage{
plotSim(dx,dy,clr=NULL, plot=TRUE)
}
\arguments{
    \item{dx}{a matrix of p vals}
    \item{dy}{a matrix of correlation vals}
    \item{clr}{Desired range of color}
    \item{plot}{ default plot =TRUE}
}
\value{a plot of similarity}
\author{
Ying Hu,Trinh Nguyen
}
\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
Sample.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim.out <- bplapply(Sample.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- Sample.Drugs
P.Values=vapply(sim.out, function(x) x[,1],FUN.VALUE=numeric(nrow(sim.out[[1]])))
estimate.cor.values=vapply(sim.out, function(x) x[,2],FUN.VALUE=numeric(nrow(sim.out[[1]])))
par(mar=c(4,4,5,2), xpd=TRUE, mfrow=c(3,3));
plotSim(dx=P.Values,dy=estimate.cor.values);
}

\name{DoInteractExp}
\alias{DoInteractExp}
\title{
Compute the interaction between the drug and KO expression
}
\description{
Computes interaction between the drug and KO expression in term of lower vs higher expression using linear model.
}
\usage{
DoInteractExp(Predtargets,Exp,DRS, GES,CutOff=3)
}
\arguments{
    \item{Predtargets}{a dataframe of drugs information and their most targeted gene with stats of correlation}
    \item{Exp}{Expression matrix}
    \item{DRS}{Drug scores matrix}
    \item{GES}{Gene effect scores matrix from KO method}
    \item{CutOff}{desired cut-off for low expression}
}
\value{
A list of drug names with their interaction values from two groups low and high expression based on the desired cut-off.
    \item{drug1 }{interaction with estimate and P vals from the linear model}
    \item{drug2 }{interaction with estimate and P vals from the linear model}
    \item{drugN }{interaction with estimate and P vals from the linear model}
}

\author{
sanjusinha7, Trinh Nguyen
}

\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
S.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim.out <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim.out) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
DrugTargetSim <- PredTarget(sim.out,D.M = Meta.data)
d.expr <- OntargetM$expression_20Q4
ExpInteract <- DoInteractExp (DrugTargetSim,d.expr,sec.prism,KO.GES,CutOff = 2)
}

\name{DoPWY}
\alias{DoPWY}
\title{Provide a probability score for each pathway for the primary of mechanism of action (MOA) of a drug}
\description{
Predicts a Primary Target at a pathway Level. It next finds the pathways that are most enriched in the genes with high DKS scores. It does this by performing a pathway enrichment test on the ranked gene list by DKS score. The output is a data frame of pathway-level probabilities for each drug to be the primary of mechanism of action.
}

\usage{
DoPWY(Sim.GES.DRS,D.M)
}

\arguments{
    \item{Sim.GES.DRS}{The list of result from "GetSim" function.}
    \item{D.M}{meta data from drug}
}

\value{
a list of drugs, where each of them is data frame containing the pathway level probability to be a primary of mechanism of action.
    \item{drug1 }{a dataframe contain the pathway level probability to be a primary MOA}
    \item{drug2 }{a dataframe contain the pathway level probability to be a primary MOA}
    \item{drugN }{a dataframe contain the pathway level probability to be a primary MOA}
}

\author{sanjusinha7, Trinh Nguyen}

\examples{
library(BiocParallel)
data (OntargetM)
set.seed (12345)
All.Drugs <- OntargetM$DrugMetadata[,"broad_id_trimmed"]
S.Drugs <- sample(All.Drugs, 5)
KO.GES <- OntargetM$avana_CRISPR
sec.prism <- OntargetM$secondary_prism
sim <- bplapply(S.Drugs,function(x) computeCor(x,sec.prism,KO.GES))
names(sim) <- S.Drugs
Meta.data <- OntargetM$DrugMetadata
Pwy.Enr <- DoPWY(sim,Meta.data)
}
